## Script (Python) "getThumbTag"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=image_id, alt, target, width=0, height=0
##title=Return the <img> tag of the image thumb, taking PIL into consideration if available. THIS SHOULD BE CACHED !
##

# Calculate width
i = context.restrictedTraverse(image_id)
w = i.width
width = min(w, width)

try:
   # We try PIL
   i = context.restrictedTraverse('%s/thumb' % (image_id, ))
   #src = i.absolute_url() + '?width=%d' % (width,) OLD, PIL unefficient
   # XXX HAVE TO USE HEIGHT AS WELL
   src = context.absolute_url() + '/' + image_id + '/thumb?width=%d' % (width,)
              
   wh = ""
except:
   # Snirf...
   i = context.restrictedTraverse(image_id)
   src = context.absolute_url() + '/' + image_id
   if width and height:
      wh = "width='%d' height='%d'" % (width, height, )
   elif width:
      wh = "width='%d'" % (width, )
   elif height:
      wh = "height='%d'" % (height, )
   else:
      wh = ""
   
return "<img src='%s' alt='%s' %s>" % (src, alt, wh)
